package aQute.lib.osgi;

import java.io.*;

public class PreprocessResource implements Resource {
    final Resource  resource;
    final Processor processor;
    String          extra;
    byte[]          calculated;

    public PreprocessResource(Processor processor, Resource r) {
        this.processor = processor;
        this.resource = r;
        extra = resource.getExtra();
    }

    public String getExtra() {
        return extra;
    }

    public long lastModified() {
        return resource.lastModified();
    }

    public InputStream openInputStream() throws IOException {
        return new ByteArrayInputStream(getBytes());
    }

    public void setExtra(String extra) {
        this.extra = extra;
    }

    public void write(OutputStream out) throws IOException {
        out.write(getBytes());
    }

    byte[] getBytes() throws IOException {
        ByteArrayOutputStream bout = new ByteArrayOutputStream(2000);
        OutputStreamWriter osw = new OutputStreamWriter(bout);
        PrintWriter pw = new PrintWriter(osw);
        InputStream in = resource.openInputStream();
        try {
            BufferedReader rdr = new BufferedReader(new InputStreamReader(in));
            String line = rdr.readLine();
            while (line != null) {
                line = processor.getReplacer().process(line);
                pw.println(line);
                line = rdr.readLine();
            }
            pw.flush();
            byte [] data= bout.toByteArray();
            return data;
                
        } finally {
            in.close();
        }        
    }
}
